#!/usr/bin/env bash
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*    This file is part of the test engine for the 11th DIMACS challenge     *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


# check if tmp-path exists
if test ! -d $CLIENTTMPDIR/${USER}-tmpdir
then
    mkdir $CLIENTTMPDIR/${USER}-tmpdir
    echo Creating directory $CLIENTTMPDIR/${USER}-tmpdir for temporary outfile
fi

TMPFILE=$CLIENTTMPDIR/${USER}-tmpdir/$TSTNAME.$FILENAME.$BINNAME.$THREADS.$TIMELIMIT.$QUEUE.stp
TMPSOLFILE=$CLIENTTMPDIR/${USER}-tmpdir/$TSTNAME.$FILENAME.$BINNAME.$THREADS.$TIMELIMIT.$QUEUE.sol
OUTFILE=$CLIENTTMPDIR/${USER}-tmpdir/${USER}.$TSTNAME.$FILENAME.$BINNAME.$THREADS.$TIMELIMIT.$QUEUE.out
ERRFILE=$CLIENTTMPDIR/${USER}-tmpdir/${USER}.$TSTNAME.$FILENAME.$BINNAME.$THREADS.$TIMELIMIT.$QUEUE.err

cp $SCRIPTPATH/$INSTANCE $TMPFILE

uname -a                            > $OUTFILE
uname -a                            > $ERRFILE
echo @01 $INSTANCE ===========      >> $OUTFILE
echo @01 $INSTANCE ===========      >> $ERRFILE
echo -----------------------------  >> $OUTFILE
date                                >> $OUTFILE
date                                >> $ERRFILE
echo -----------------------------  >> $OUTFILE
date +"@03 %s"                      >> $OUTFILE

$SHELL -c " ulimit -f 2000000; ulimit -s unlimited; $BINPATH/$BINNAME $TMPFILE $TIMELIMIT $THREADS $TMPSOLFILE" 2>>$ERRFILE | tee -a $OUTFILE
retcode=${PIPESTATUS[0]}
if test $retcode != 0
then
  echo "$BINNAME returned with error code $retcode." >>$ERRFILE
fi

date +"@04 %s"                      >> $OUTFILE
echo -----------------------------  >> $OUTFILE
date                                >> $OUTFILE
echo -----------------------------  >> $OUTFILE
date                                >> $ERRFILE
echo                                >> $OUTFILE
echo =ready=                        >> $OUTFILE


mv $OUTFILE $SCRIPTPATH/results/logs/${USER}.$TSTNAME.$FILENAME.$BINNAME.$THREADS.$TIMELIMIT.$QUEUE.out
mv $ERRFILE $SCRIPTPATH/results/logs/${USER}.$TSTNAME.$FILENAME.$BINNAME.$THREADS.$TIMELIMIT.$QUEUEerr
mv $TMPSOLFILE $SOLFILE
rm -f $TMPFILE
